=== debian/changelog ===
mrpt (1:1.0.0-1) unstable; urgency=low

  * New version of upstream sources.
  * Removed unneeded Debian package mrpt-libs (Closes: #698360)

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Fri, 01 Mar 2013 13:23:55 +0100
